include(`misc/utils.m4')dnl vim-m4-syntax: quote=«,» comment=\\
#ifndef X86_64_H
#define X86_64_H

#include "../utils.h"

/*******************************************************************************
divert(«-1»)dnl

define(«registers», «RAX, RCX, RDX, RBX, R8, R9, R10, R11, R12, R13, R14, R15»)

define(«x86_encoding_of», «translit(esyscmd(«echo '$1' | ./tools/x86_64dump»),«
»)»)
define(«assemble», «hextox(x86_encoding_of($1)) Y("$1")»)

divert(«0»)dnl

Types:

R: registers
V: BYTE(X), WORD(X)
Q: QWORD(X)

To use these macros, either define X(x) as (x), to make lists of bytes, or
define Y(s) as whatever you want to do with a string literal. Keep the other
defined as an empty expansion.

*******************************************************************************/

#define PUSH(A_RV) PUSH_ ## A_RV
#define POP(A_R) POP_ ## A_R
#define MOV(DST_R,SRC_RV) MOV_ ## DST_R ## _ ## SRC_RV
#define ADD(DST_R,SRC_RV) ADD_ ## DST_R ## _ ## SRC_RV
#define SUB(DST_R,SRC_RV) SUB_ ## DST_R ## _ ## SRC_RV

/*******************************************************************************
Implementations (auto generated):
*******************************************************************************/

#define XX(x) X(BYTE_0xFF(x)) X(BYTE_0xFF00(x))
#define XXX(x) X(BYTE_0xFF(x)) X(BYTE_0xFF00(x)) X(BYTE_0xFF0000(x))
#define XXXX(x) X(BYTE_0xFF(x)) X(BYTE_0xFF00(x)) X(BYTE_0xFF0000(x)) X(BYTE_0xFF000000(x))
foreachq(register, «registers», «#define PUSH_«»register«» assemble(«push register»)
»)
#define PUSH_BYTE(x) X(0x6a) X(x) Y("push " #x)
#define PUSH_WORD(x) X(0x86) XXXX(x) Y("push " #x)

foreachq(register, «registers», «#define POP_«»register«» assemble(«pop register»)
»)
foreachq(registera, «registers», «
foreachq(registerb, «registers», «ifelse(registera,registerb,,#define MOV_«»registera«»_«»registerb«» assemble(«mov registera«,»registerb»)
)»)»)
foreachq(register, «registers», «#define MOV_«»register«»_WORD(x) hextox(rtrimn(x86_encoding_of(«mov »register«, 0»), 8)) XXXX(x) Y("mov register," #x)
»)

foreachq(registera, «registers», «
foreachq(registerb, «registers», «ifelse(registera,registerb,,#define ADD_«»registera«»_«»registerb«» assemble(«add registera«,»registerb»)
)»)»)
foreachq(register, «registers», «#define ADD_«»register«»_WORD(x) hextox(rtrimn(x86_encoding_of(«add »register«, 0x12345678»), 8)) XXXX(x) Y("add register," #x)
»)

foreachq(registera, «registers», «
foreachq(registerb, «registers», «ifelse(registera,registerb,,#define SUB_«»registera«»_«»registerb«» assemble(«sub registera«,»registerb»)
)»)»)
foreachq(register, «registers», «#define SUB_«»register«»_WORD(x) hextox(rtrimn(x86_encoding_of(«sub »register«, 0x12345678»), 8)) XXXX(x) Y("sub register," #x)
»)

#endif /* X86_64_H */
