#ifndef X86_64_OPCODES_H
#define X86_64_OPCODES_H

#include "../utils.h"

/* for list creation, other uses can override X() */
#define X(x) (x),

#define XX(x) X(BYTE_0xFF(x)) X(BYTE_0xFF00(x))
#define XXX(x) X(BYTE_0xFF(x)) X(BYTE_0xFF00(x)) X(BYTE_0xFF0000(x))
#define XXXX(x) X(BYTE_0xFF(x)) X(BYTE_0xFF00(x)) X(BYTE_0xFF0000(x)) X(BYTE_0xFF000000(x))

#define PUSH_RAX X(0x50)
#define PUSH_RCX X(0x51)
#define PUSH_RDX X(0x52)
#define PUSH_RBX X(0x53)
#define PUSH_RBP X(0x55)
#define PUSH_R8 XX(0x4150)
#define PUSH_R9 XX(0x4151)
#define PUSH_R10 XX(0x4152)
#define PUSH_R11 XX(0x4153)
#define PUSH_R12 XX(0x4154)
#define PUSH_R13 XX(0x4155)
#define PUSH_R14 XX(0x4156)
#define PUSH_R15 XX(0x4157)
#define PUSH_BYTE(x) X(0x6a) X(x)
#define PUSH_WORD(x) X(0x68) XXXX(x)

#define POP_RAX X(0x58)
#define POP_RCX X(0x59)
#define POP_RDX X(0x5a)
#define POP_RBX X(0x5b)
#define POP_R8 XX(0x4158)
#define POP_R9 XX(0x4159)
#define POP_R10 XX(0x415a)
#define POP_R11 XX(0x415b)
#define POP_R12 XX(0x415c)
#define POP_R13 XX(0x415d)
#define POP_R14 XX(0x415e)
#define POP_R15 XX(0x415f)

#include "./x86_64_mov_opcodes.h"

#endif /* X86_64_OPCODES_H */
